diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Packet.c olsrd-current/lib/bmf/src/Packet.c
--- olsrd-0.5.0/lib/bmf/src/Packet.c	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/Packet.c	2007-04-22 19:40:38.000000000 +0200
@@ -32,94 +32,115 @@
 
 /* -------------------------------------------------------------------------
  * File       : Packet.c
- * Description: BMF and IP packet processing functions
+ * Description: IP packet and Ethernet frame processing functions
  * Created    : 29 Jun 2006
  *
- * $Id: Packet.c,v 1.3 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 #include "Packet.h"
 
 /* System includes */
+#include <stddef.h> /* NULL */
 #include <assert.h> /* assert() */
-#include <sys/types.h> /* u_int32_t */
+#include <string.h> /* memcpy() */
+#include <sys/types.h> /* u_int8_t, u_int16_t, u_int32_t */
 #include <netinet/in.h> /* ntohs(), htons() */
 #include <netinet/ip.h> /* struct iphdr */
 
-#include <stdio.h>
 /* -------------------------------------------------------------------------
- * Function   : GetIpPacketLength
- * Description: Retrieve the IP packet length (in bytes) of the passed
- *              ethernet-IP packet
- * Input      : buffer - the ethernet-IP packet
+ * Function   : IsIpFragment
+ * Description: Check if an IP packet is an IP fragment
+ * Input      : ipPacket - the IP packet
+ * Output     : none
+ * Return     : true (1) or false (0)
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+int IsIpFragment(unsigned char* ipPacket)
+{
+  struct ip* iph;
+
+  assert(ipPacket != NULL);
+
+  iph = (struct ip*) ipPacket;
+  if ((ntohs(iph->ip_off) & IP_OFFMASK) != 0)
+  {
+    return 1;
+  }
+  return 0;
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : GetTotalLength
+ * Description: Retrieve the total length of the IP packet (in bytes) of
+ *              an IP packet
+ * Input      : ipPacket - the IP packet
  * Output     : none
  * Return     : IP packet length
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-int GetIpPacketLength(unsigned char* buffer)
+u_int16_t GetTotalLength(unsigned char* ipPacket)
 {
   struct iphdr* iph;
 
-  assert(buffer != NULL);
+  assert(ipPacket != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
   return ntohs(iph->tot_len);
 }
 
 /* -------------------------------------------------------------------------
- * Function   : GetIpHeaderLength
- * Description: Retrieve the IP header length (in bytes) of the passed
- *              ethernet-IP packet
- * Input      : buffer - the ethernet-IP packet
+ * Function   : GetHeaderLength
+ * Description: Retrieve the IP header length (in bytes) of an IP packet
+ * Input      : ipPacket - the IP packet
  * Output     : none
  * Return     : IP header length
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-int GetIpHeaderLength(unsigned char* buffer)
+unsigned int GetHeaderLength(unsigned char* ipPacket)
 {
   struct iphdr* iph;
 
-  assert(buffer != NULL);
+  assert(ipPacket != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
   return iph->ihl << 2;
 }
 
 /* -------------------------------------------------------------------------
- * Function   : GetIpTtl
+ * Function   : GetTtl
  * Description: Retrieve the TTL (Time To Live) value from the IP header of
- *              the passed ethernet-IP packet
- * Input      : buffer - the ethernet-IP packet
+ *              an IP packet
+ * Input      : ipPacket - the IP packet
  * Output     : none
  * Return     : TTL value
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-int GetIpTtl(unsigned char* buffer)
+u_int8_t GetTtl(unsigned char* ipPacket)
 {
   struct iphdr* iph;
 
-  assert(buffer != NULL);
+  assert(ipPacket != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
   return iph->ttl;
 }
 
 /* -------------------------------------------------------------------------
  * Function   : SaveTtlAndChecksum
  * Description: Save the TTL (Time To Live) value and IP checksum as found in
- *              the IP header of the passed ethernet-IP packet
- * Input      : buffer - the ethernet-IP packet
+ *              the IP header of an IP packet
+ * Input      : ipPacket - the IP packet
  * Output     : sttl - the TTL and checksum values
  * Return     : none
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-void SaveTtlAndChecksum(unsigned char* buffer, struct TSaveTtl* sttl)
+void SaveTtlAndChecksum(unsigned char* ipPacket, struct TSaveTtl* sttl)
 {
   struct iphdr* iph;
 
-  assert(buffer != NULL && sttl != NULL);
+  assert(ipPacket != NULL && sttl != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
   sttl->ttl = iph->ttl;
   sttl->check = ntohs(iph->check);
 }
@@ -127,20 +148,20 @@
 /* -------------------------------------------------------------------------
  * Function   : RestoreTtlAndChecksum
  * Description: Restore the TTL (Time To Live) value and IP checksum in
- *              the IP header of the passed ethernet-IP packet
- * Input      : buffer - the ethernet-IP packet
+ *              the IP header of an IP packet
+ * Input      : ipPacket - the IP packet
  *              sttl - the TTL and checksum values
  * Output     : none
  * Return     : none
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-void RestoreTtlAndChecksum(unsigned char* buffer, struct TSaveTtl* sttl)
+void RestoreTtlAndChecksum(unsigned char* ipPacket, struct TSaveTtl* sttl)
 {
   struct iphdr* iph;
 
-  assert(buffer != NULL && sttl != NULL);
+  assert(ipPacket != NULL && sttl != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
   iph->ttl = sttl->ttl;
   iph->check = htons(sttl->check);
 }
@@ -149,22 +170,118 @@
  * Function   : DecreaseTtlAndUpdateHeaderChecksum
  * Description: For an IP packet, decrement the TTL value and update the IP header
  *              checksum accordingly.
- * Input      : buffer - the ethernet-IP packet
+ * Input      : ipPacket - the IP packet
  * Output     : none
  * Return     : none
  * Data Used  : none
  * Notes      : See also RFC1141
  * ------------------------------------------------------------------------- */
-void DecreaseTtlAndUpdateHeaderChecksum(unsigned char* buffer)
+void DecreaseTtlAndUpdateHeaderChecksum(unsigned char* ipPacket)
 {
   struct iphdr* iph;
   u_int32_t sum;
 
-  assert(buffer != NULL);
+  assert(ipPacket != NULL);
 
-  iph = (struct iphdr*) (buffer + IP_HDR_OFFSET);
+  iph = (struct iphdr*) ipPacket;
 
   iph->ttl--; /* decrement ttl */
   sum = ntohs(iph->check) + 0x100; /* increment checksum high byte */
   iph->check = htons(sum + (sum>>16)); /* add carry */
 }
+
+/* -------------------------------------------------------------------------
+ * Function   : GetEtherType
+ * Description: Retrieve the EtherType of an Ethernet frame
+ * Input      : ethernetFrame - the Ethernet frame
+ * Output     : none
+ * Return     : EtherType
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+u_int16_t GetEtherType(unsigned char* ethernetFrame)
+{
+  u_int16_t type;
+  memcpy(&type, ethernetFrame + ETH_TYPE_OFFSET, 2);
+  return ntohs(type);
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : GetIpHeader
+ * Description: Retrieve the IP header from an Ethernet frame
+ * Input      : ethernetFrame - the Ethernet frame
+ * Output     : none
+ * Return     : IP header
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+struct ip* GetIpHeader(unsigned char* ethernetFrame)
+{
+  return (struct ip*)(ethernetFrame + IP_HDR_OFFSET);
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : GetIpPacket
+ * Description: Retrieve the IP packet from an Ethernet frame
+ * Input      : ethernetFrame - the Ethernet frame
+ * Output     : none
+ * Return     : IP packet
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+unsigned char* GetIpPacket(unsigned char* ethernetFrame)
+{
+  return ethernetFrame + IP_HDR_OFFSET;
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : GetFrameLength
+ * Description: Return the Ethernet frame length of an Ethernet frame containing
+ *              an IP packet
+ * Input      : ethernetFrame - the Ethernet frame
+ * Output     : none
+ * Return     : The frame length
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+u_int16_t GetFrameLength(unsigned char* ethernetFrame)
+{
+  return GetTotalLength(GetIpPacket(ethernetFrame)) + IP_HDR_OFFSET;
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : SetFrameSourceMac
+ * Description: Set the source MAC address of an Ethernet frame
+ * Input      : ethernetFrame - the Ethernet frame
+              : srcMac - the source MAC address
+ * Output     : none
+ * Return     : none
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+void SetFrameSourceMac(unsigned char* ethernetFrame, unsigned char* srcMac)
+{
+  memcpy(ethernetFrame + IFHWADDRLEN, srcMac, IFHWADDRLEN);
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : GetEthernetFrame
+ * Description: Retrieve the Ethernet frame from BMF encapsulation UDP data
+ * Input      : encapsulationUdpData - the encapsulation UDP data
+ * Output     : none
+ * Return     : The Ethernet frame
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+unsigned char* GetEthernetFrame(unsigned char* encapsulationUdpData)
+{
+  return encapsulationUdpData + ENCAP_HDR_LEN;
+}
+
+/* -------------------------------------------------------------------------
+ * Function   : GetEncapsulationUdpDataLength
+ * Description: Return the length of BMF encapsulation UDP data
+ * Input      : encapsulationUdpData - the encapsulation UDP data
+ * Output     : none
+ * Return     : The packet length
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+u_int16_t GetEncapsulationUdpDataLength(unsigned char* encapsulationUdpData)
+{
+  return GetFrameLength(GetEthernetFrame(encapsulationUdpData)) + ENCAP_HDR_LEN;
+}
+
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Packet.h olsrd-current/lib/bmf/src/Packet.h
--- olsrd-0.5.0/lib/bmf/src/Packet.h	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/Packet.h	2007-04-22 19:40:38.000000000 +0200
@@ -38,7 +38,6 @@
  * Description: BMF and IP packet processing functions
  * Created    : 29 Jun 2006
  *
- * $Id: Packet.h,v 1.2 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 /* System includes */
@@ -67,7 +66,7 @@
   u_int32_t futureExpansion3;
 } __attribute__((__packed__));
 
-#define	ENCAP_HDR_LEN (sizeof(struct TEncapHeader))
+#define	ENCAP_HDR_LEN ((int)sizeof(struct TEncapHeader))
 
 struct TSaveTtl
 {
@@ -75,11 +74,19 @@
   u_int16_t check;
 } __attribute__((__packed__));
 
-int GetIpPacketLength(unsigned char* buffer);
-int GetIpHeaderLength(unsigned char* buffer);
-int GetIpTtl(unsigned char* buffer);
-void SaveTtlAndChecksum(unsigned char* buffer, struct TSaveTtl* sttl);
-void RestoreTtlAndChecksum(unsigned char* buffer, struct TSaveTtl* sttl);
-void DecreaseTtlAndUpdateHeaderChecksum(unsigned char* buffer);
+int IsIpFragment(unsigned char* ipPacket);
+u_int16_t GetTotalLength(unsigned char* ipPacket);
+unsigned int GetHeaderLength(unsigned char* ipPacket);
+u_int8_t GetTtl(unsigned char* ipPacket);
+void SaveTtlAndChecksum(unsigned char* ipPacket, struct TSaveTtl* sttl);
+void RestoreTtlAndChecksum(unsigned char* ipPacket, struct TSaveTtl* sttl);
+void DecreaseTtlAndUpdateHeaderChecksum(unsigned char* ipPacket);
+u_int16_t GetEtherType(unsigned char* ethernetFrame);
+struct ip* GetIpHeader(unsigned char* ethernetFrame);
+unsigned char* GetIpPacket(unsigned char* ethernetFrame);
+u_int16_t GetFrameLength(unsigned char* ethernetFrame);
+void SetFrameSourceMac(unsigned char* ethernetFrame, unsigned char* srcMac);
+unsigned char* GetEthernetFrame(unsigned char* encapsulationUdpData);
+u_int16_t GetEncapsulationUdpDataLength(unsigned char* encapsulationUdpData);
 
 #endif /* _BMF_PACKET_H */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/PacketHistory.c olsrd-current/lib/bmf/src/PacketHistory.c
--- olsrd-0.5.0/lib/bmf/src/PacketHistory.c	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/PacketHistory.c	2007-04-22 19:40:38.000000000 +0200
@@ -36,12 +36,12 @@
  *              multicast IP packets.
  * Created    : 29 Jun 2006
  *
- * $Id: PacketHistory.c,v 1.2 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 #include "PacketHistory.h"
 
 /* System includes */
+#include <stddef.h> /* NULL */
 #include <assert.h> /* assert() */
 #include <string.h> /* memset */
 #include <sys/types.h> /* u_int16_t, u_int32_t */
@@ -50,7 +50,7 @@
 /* OLSRD includes */
 #include "olsr.h" /* olsr_printf */
 
-/* Plugin includes */
+/* NULLPlugin includes */
 #include "Packet.h"
 
 static u_int32_t PacketHistory[HISTORY_TABLE_SIZE];
@@ -146,23 +146,23 @@
 
 /* -------------------------------------------------------------------------
  * Function   : PacketCrc32
- * Description: Calculates the CRC-32 value for an Ethernet packet
- * Input      : ethPkt - the Ethernet packet
- *              len - the number of octets in the Ethernet packet
+ * Description: Calculates the CRC-32 value for an Ethernet frame
+ * Input      : ethernetFrame - the Ethernet frame
+ *              len - the number of octets in the Ethernet frame
  * Output     : none
  * Return     : 32-bits hash value
  * Data Used  : none
  * Notes      : The source and destination MAC address are not taken into account
  *              in the CRC calculation.
  * ------------------------------------------------------------------------- */
-u_int32_t PacketCrc32(unsigned char* ethPkt, ssize_t len)
+u_int32_t PacketCrc32(unsigned char* ethernetFrame, ssize_t len)
 {
   ssize_t nCrcBytes;
   struct TSaveTtl sttl;
-  struct iphdr* iph;
+  struct ip* ipHeader;
   u_int32_t result;
 
-  assert(ethPkt != NULL);
+  assert(ethernetFrame != NULL);
 
   /* Start CRC calculation at ethertype; skip source and destination MAC 
    * addresses, and ethertype.
@@ -183,15 +183,15 @@
     nCrcBytes = CRC_UPTO_NBYTES;
   }
 
-  SaveTtlAndChecksum(ethPkt, &sttl);
+  SaveTtlAndChecksum(GetIpPacket(ethernetFrame), &sttl);
 
-  iph = (struct iphdr*) (ethPkt + IP_HDR_OFFSET);
-  iph->ttl = 0xFF; /* fixed value of TTL for CRC-32 calculation */
-  iph->check = 0x5A5A; /* fixed value of IP header checksum for CRC-32 calculation */
+  ipHeader = GetIpHeader(ethernetFrame);
+  ipHeader->ip_ttl = 0xFF; /* fixed value of TTL for CRC-32 calculation */
+  ipHeader->ip_sum = 0x5A5A; /* fixed value of IP header checksum for CRC-32 calculation */
 
-  result = CalcCrc32(ethPkt + IP_HDR_OFFSET, nCrcBytes);
+  result = CalcCrc32(ethernetFrame + IP_HDR_OFFSET, nCrcBytes);
 
-  RestoreTtlAndChecksum(ethPkt, &sttl);
+  RestoreTtlAndChecksum(GetIpPacket(ethernetFrame), &sttl);
   return result;
 }
 
@@ -209,7 +209,7 @@
  * Return     : none
  * Data Used  : PacketHistory
  * ------------------------------------------------------------------------- */
-void InitPacketHistory()
+void InitPacketHistory(void)
 {
   memset(PacketHistory, 0, sizeof(PacketHistory));
   GenerateCrc32Table();
@@ -277,7 +277,7 @@
  * Return     : none
  * Data Used  : PacketHistory
  * ------------------------------------------------------------------------- */
-void PrunePacketHistory(void* useless)
+void PrunePacketHistory(void* useless __attribute__((unused)))
 {
   uint i;
   for (i = 0; i < HISTORY_TABLE_SIZE; i++)
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/PacketHistory.h olsrd-current/lib/bmf/src/PacketHistory.h
--- olsrd-0.5.0/lib/bmf/src/PacketHistory.h	2007-02-10 18:05:56.000000000 +0100
+++ olsrd-current/lib/bmf/src/PacketHistory.h	2007-04-22 19:40:39.000000000 +0200
@@ -39,7 +39,6 @@
  *              multicast IP packets.
  * Created    : 29 Jun 2006
  *
- * $Id: PacketHistory.h,v 1.2 2007/02/10 17:05:56 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 #include <sys/types.h> /* ssize_t */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dot_draw/src/olsrd_dot_draw.c olsrd-current/lib/dot_draw/src/olsrd_dot_draw.c
--- olsrd-0.5.0/lib/dot_draw/src/olsrd_dot_draw.c	2006-04-11 20:43:12.000000000 +0200
+++ olsrd-current/lib/dot_draw/src/olsrd_dot_draw.c	2007-04-20 16:06:18.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_dot_draw.c,v 1.22 2006/04/11 18:43:12 kattemat Exp $
+ * $Id: olsrd_dot_draw.c,v 1.23 2007/04/20 14:06:18 bernd67 Exp $
  */
 
 /*
@@ -98,27 +98,24 @@
 static void
 ipc_action(int);
 
-static void inline
+static void
 ipc_print_neigh_link(struct neighbor_entry *neighbor);
 
-static void inline
+static void
 ipc_print_tc_link(struct tc_entry *entry, struct topo_dst *dst_entry);
 
-static void inline
+static void
 ipc_print_net(union olsr_ip_addr *, union olsr_ip_addr *, union hna_netmask *);
 
 static int
-ipc_send(char *, int);
+ipc_send(const char *, int);
 
 static int
-ipc_send_str(char *);
+ipc_send_str(const char *);
 
 static double 
 calc_etx(double, double);
 
-static void inline
-ipc_print_neigh_link(struct neighbor_entry *);
-
 
 /**
  *Do initialization here
@@ -127,11 +124,13 @@
  *function in uolsrd_plugin.c
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
   /* Initial IPC value */
   ipc_open = 0;
   ipc_socket_up = 0;
+  ipc_socket = -1;
+  ipc_connection = -1;
 
   /* Register the "ProcessChanges" function */
   register_pcf(&pcf_event);
@@ -146,19 +145,19 @@
  * destructor - called at unload
  */
 void
-olsr_plugin_exit()
+olsr_plugin_exit(void)
 {
   if(ipc_open)
     close(ipc_socket);
 }
 
 
-static void inline
+static void
 ipc_print_neigh_link(struct neighbor_entry *neighbor)
 {
   char buf[256];
-  char* adr;
-  double etx=0.0;
+  const char* adr;
+  double etx = 0.0;
   char* style = "solid";
   struct link_entry* link;
   adr = olsr_ip_to_string(&olsr_cnf->main_addr);
@@ -188,7 +187,7 @@
 
 
 static int
-plugin_ipc_init()
+plugin_ipc_init(void)
 {
   struct sockaddr_in sin;
   olsr_u32_t yes = 1;
@@ -249,40 +248,35 @@
 
 
 static void
-ipc_action(int fd)
+ipc_action(int fd __attribute__((unused)))
 {
   struct sockaddr_in pin;
-  socklen_t addrlen;
-  char *addr;  
-
-  addrlen = sizeof(struct sockaddr_in);
+  socklen_t addrlen = sizeof(struct sockaddr_in);
 
   if (ipc_open)
     {
-      while(close(ipc_connection) == -1) 
-        {
-          olsr_printf(1, "(DOT DRAW) Error on closing previously active TCP connection on fd %d: %s\n", ipc_connection, strerror(errno));
-          if (errno != EINTR)
-            {
-	      break;
-            }
-        }
+      int rc;
+      do {
+        rc = close(ipc_connection);
+      } while (rc == -1 && (errno == EINTR || errno == EAGAIN));
+      if (rc == -1) {
+        olsr_printf(1, "(DOT DRAW) Error on closing previously active TCP connection on fd %d: %s\n", ipc_connection, strerror(errno));
+      }
       ipc_open = 0;
     }
   
   if ((ipc_connection = accept(ipc_socket, (struct sockaddr *)  &pin, &addrlen)) == -1)
     {
       olsr_printf(1, "(DOT DRAW)IPC accept: %s\n", strerror(errno));
-      exit(1);
     }
   else
     {
-      addr = inet_ntoa(pin.sin_addr);
+      char *addr = inet_ntoa(pin.sin_addr);
       if(ntohl(pin.sin_addr.s_addr) != ntohl(ipc_accept_ip.s_addr))
 	{
 	  olsr_printf(1, "Front end-connection from foregin host(%s) not allowed!\n", addr);
 	  close(ipc_connection);
-	  return;
+          ipc_connection = -1;
 	}
       else
 	{
@@ -395,11 +389,11 @@
 }
 
 
-static void inline
+static void
 ipc_print_tc_link(struct tc_entry *entry, struct topo_dst *dst_entry)
 {
   char buf[256];
-  char* adr;
+  const char* adr;
   double etx = calc_etx( dst_entry->link_quality, dst_entry->inverse_link_quality );
 
   adr = olsr_ip_to_string(&entry->T_last_addr);
@@ -412,10 +406,10 @@
 }
 
 
-static void inline
+static void
 ipc_print_net(union olsr_ip_addr *gw, union olsr_ip_addr *net, union hna_netmask *mask)
 {
-  char *adr;
+  const char *adr;
 
   adr = olsr_ip_to_string(gw);
   ipc_send_str("\"");
@@ -438,7 +432,7 @@
 }
 
 static int
-ipc_send_str(char *data)
+ipc_send_str(const char *data)
 {
   if(!ipc_open)
     return 0;
@@ -447,16 +441,17 @@
 
 
 static int
-ipc_send(char *data, int size)
+ipc_send(const char *data, int size)
 {
   if(!ipc_open)
     return 0;
 
 #if defined __FreeBSD__ || defined __NetBSD__ || defined __OpenBSD__ || defined __MacOSX__
-  if (send(ipc_connection, data, size, 0) < 0) 
+#define FLAGS 0
 #else
-  if (send(ipc_connection, data, size, MSG_NOSIGNAL) < 0) 
+#define FLAGS MSG_NOSIGNAL
 #endif
+  if (send(ipc_connection, data, size, FLAGS) == -1)
     {
       olsr_printf(1, "(DOT DRAW)IPC connection lost!\n");
       close(ipc_connection);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dot_draw/src/olsrd_dot_draw.h olsrd-current/lib/dot_draw/src/olsrd_dot_draw.h
--- olsrd-0.5.0/lib/dot_draw/src/olsrd_dot_draw.h	2005-05-29 14:47:40.000000000 +0200
+++ olsrd-current/lib/dot_draw/src/olsrd_dot_draw.h	2007-04-20 16:20:11.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_dot_draw.h,v 1.7 2005/05/29 12:47:40 br1 Exp $
+ * $Id: olsrd_dot_draw.h,v 1.8 2007/04/20 14:20:11 bernd67 Exp $
  */
 
 /*
@@ -51,10 +51,15 @@
 extern struct in_addr ipc_accept_ip;
 extern int ipc_port;
 
+int 
+olsrd_plugin_interface_version(void);
 
 int
 olsrd_plugin_init(void);
 
+int
+olsrd_plugin_register_param(char *key, char *value);
+
 void
 olsr_plugin_exit(void);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dot_draw/src/olsrd_plugin.c olsrd-current/lib/dot_draw/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/dot_draw/src/olsrd_plugin.c	2005-06-02 17:09:37.000000000 +0200
+++ olsrd-current/lib/dot_draw/src/olsrd_plugin.c	2007-04-20 16:06:18.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_plugin.c,v 1.12 2005/06/02 15:09:37 br1 Exp $
+ * $Id: olsrd_plugin.c,v 1.14 2007/04/20 14:06:18 bernd67 Exp $
  */
 
 /*
@@ -51,6 +51,7 @@
 #include <sys/types.h>
 #include <netinet/in.h>
 
+#include "olsr.h"
 #include "olsrd_plugin.h"
 #include "olsrd_dot_draw.h"
 
@@ -77,7 +78,7 @@
  *Constructor
  */
 static void
-my_init()
+my_init(void)
 {
   /* Print plugin info to stdout */
   printf("%s\n", MOD_DESC);
@@ -92,7 +93,7 @@
  *Destructor
  */
 static void
-my_fini()
+my_fini(void)
 {
   /* Calls the destruction function
    * olsr_plugin_exit()
@@ -105,7 +106,7 @@
 
 
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return PLUGIN_INTERFACE_VERSION;
 }
@@ -116,14 +117,17 @@
 {
   if(!strcmp(key, "port"))
     {
-     ipc_port = atoi(value);
-     printf("(DOT DRAW) listening on port: %d\n", ipc_port);
+      ipc_port = atoi(value);
+      olsr_printf(0, "(DOT DRAW) listening on port: %d\n", ipc_port);
+      return 1;
     }
 
   if(!strcmp(key, "accept"))
     {
-	inet_aton(value, &ipc_accept_ip);
-	printf("(DOT DRAW) accept only: %s\n", inet_ntoa(ipc_accept_ip));
+      inet_aton(value, &ipc_accept_ip);
+      olsr_printf(0, "(DOT DRAW) accept only: %s\n", inet_ntoa(ipc_accept_ip));
+      return 1;
     }
+  olsr_printf(0, "(DOT DRAW) ignored: %s=\"%s\"\n", key, value);
   return 1;
 }
